diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/lr-wpan/model/lr-wpan-mac-base.h ns-3.42/src/lr-wpan/model/lr-wpan-mac-base.h
--- ns-3.41/src/lr-wpan/model/lr-wpan-mac-base.h	2024-02-09 14:44:07.953790400 -0800
+++ ns-3.42/src/lr-wpan/model/lr-wpan-mac-base.h	2024-05-29 15:29:46.976073300 -0700
@@ -32,6 +32,8 @@
 
 namespace ns3
 {
+namespace lrwpan
+{
 
 /**
  * \ingroup lr-wpan
@@ -45,7 +47,7 @@
  * (Table 6: Status Enumerations and Section 6.1.23)
  *
  */
-enum class LrWpanMacStatus : std::uint8_t
+enum class MacStatus : std::uint8_t
 {
     SUCCESS = 0,              //!< The operation was completed successfully.
     FULL_CAPACITY = 0x01,     //!< PAN at capacity. Association Status field (std. 2006, Table 83)
@@ -84,7 +86,7 @@
     LIMIT_REACHED = 0xfa,     //!< PAN descriptors stored reached max capacity.
     READ_ONLY = 0xfb,         //!< SET/GET request issued for a read only attribute.
     SCAN_IN_PROGRESS = 0xfc,  //!< Scan failed because already performing another scan.
-    SUPERFRAME_OVERLAP = 0xfd //!< Coordinator sperframe and this device superframe tx overlap.
+    SUPERFRAME_OVERLAP = 0xfd //!< Coordinator superframe and this device superframe tx overlap.
 };
 
 /**
@@ -92,7 +94,7 @@
  *
  * table 80 of 802.15.4
  */
-enum LrWpanAddressMode
+enum AddressMode
 {
     NO_PANID_ADDR = 0,
     ADDR_MODE_RESERVED = 1,
@@ -105,7 +107,7 @@
  *
  * Table 30 of IEEE 802.15.4-2011
  */
-enum LrWpanMlmeScanType
+enum MlmeScanType
 {
     MLMESCAN_ED = 0x00,
     MLMESCAN_ACTIVE = 0x01,
@@ -120,13 +122,13 @@
  */
 struct McpsDataRequestParams
 {
-    LrWpanAddressMode m_srcAddrMode{SHORT_ADDR}; //!< Source address mode
-    LrWpanAddressMode m_dstAddrMode{SHORT_ADDR}; //!< Destination address mode
-    uint16_t m_dstPanId{0};                      //!< Destination PAN identifier
-    Mac16Address m_dstAddr;                      //!< Destination address
-    Mac64Address m_dstExtAddr;                   //!< Destination extended address
-    uint8_t m_msduHandle{0};                     //!< MSDU handle
-    uint8_t m_txOptions{0};                      //!< Tx Options (bitfield)
+    AddressMode m_srcAddrMode{SHORT_ADDR}; //!< Source address mode
+    AddressMode m_dstAddrMode{SHORT_ADDR}; //!< Destination address mode
+    uint16_t m_dstPanId{0};                //!< Destination PAN identifier
+    Mac16Address m_dstAddr;                //!< Destination address
+    Mac64Address m_dstExtAddr;             //!< Destination extended address
+    uint8_t m_msduHandle{0};               //!< MSDU handle
+    uint8_t m_txOptions{0};                //!< Tx Options (bitfield)
 };
 
 /**
@@ -160,11 +162,11 @@
  */
 struct MlmeScanRequestParams
 {
-    LrWpanMlmeScanType m_scanType{MLMESCAN_PASSIVE}; //!< Indicates the type of scan performed as
-                                                     //!< described in IEEE 802.15.4-2011 (5.1.2.1).
-    uint32_t m_scanChannels{0x7FFF800};              //!< The channel numbers to be scanned.
-                                                     //!< Default: (0x7FFF800 = Ch11-Ch26)
-                                                     //!< 27 LSB (b0,b1,...,b26) = channels
+    MlmeScanType m_scanType{MLMESCAN_PASSIVE}; //!< Indicates the type of scan performed as
+                                               //!< described in IEEE 802.15.4-2011 (5.1.2.1).
+    uint32_t m_scanChannels{0x7FFF800};        //!< The channel numbers to be scanned.
+                                               //!< Default: (0x7FFF800 = Ch11-Ch26)
+                                               //!< 27 LSB (b0,b1,...,b26) = channels
     uint8_t m_scanDuration{14}; //!< The factor (0-14) used to calculate the length of time
                                 //!< to spend scanning.
                                 //!< scanDurationSymbols =
@@ -202,9 +204,9 @@
     Mac64Address m_extDevAddr;     //!< The extended address of the device requesting association
     Mac16Address m_assocShortAddr; //!< The short address allocated by the coordinator on successful
                                    //!< assoc. FF:FF = Unsuccessful
-    LrWpanMacStatus m_status{
-        LrWpanMacStatus::ACCESS_DENIED}; //!< The status of the association
-                                         //!< attempt (As defined on Table 83 IEEE 802.15.4-2006)
+    MacStatus m_status{
+        MacStatus::ACCESS_DENIED}; //!< The status of the association
+                                   //!< attempt (As defined on Table 83 IEEE 802.15.4-2006)
 };
 
 /**
@@ -238,8 +240,8 @@
  */
 struct MlmePollRequestParams
 {
-    LrWpanAddressMode m_coorAddrMode{SHORT_ADDR}; //!< The addressing mode of the coordinator
-                                                  //!< to which the pool is intended.
+    AddressMode m_coorAddrMode{SHORT_ADDR}; //!< The addressing mode of the coordinator
+                                            //!< to which the pool is intended.
     uint16_t m_coorPanId{0};      //!< The PAN id of the coordinator to which the poll is intended.
     Mac16Address m_coorShortAddr; //!< Coordinator short address.
     Mac64Address m_coorExtAddr;   //!< Coordinator extended address.
@@ -248,18 +250,56 @@
 /**
  * \ingroup lr-wpan
  *
- * IEEE802.15.4-2011 MAC PIB Attribute Identifiers Table 52 in section 6.4.2
- *
+ * IEEE 802.15.4-2006 PHY and MAC PIB Attribute Identifiers Table 23 and Table 86.
+ * Note: Attribute identifiers use standardized values.
  */
-enum LrWpanMacPibAttributeIdentifier
+enum MacPibAttributeIdentifier
 {
-    macBeaconPayload = 0,
-    macBeaconPayloadLength = 1,
-    macShortAddress = 2,
-    macExtendedAddress = 3,
-    macPanId = 4,
-    pCurrentChannel = 100,
-    pCurrentPage = 101,
+    pCurrentChannel = 0x00,      //!< RF channel used for transmissions and receptions.
+    pCurrentPage = 0x04,         //!< The current channel page.
+    macAckWaitDuration = 0x40,   //!< Maximum number of symbols to wait for an acknowledgment.
+    macAssociationPermit = 0x41, //!< Indication of whether a coordinator is allowing association.
+    macAutoRequest = 0x42, //!< Indication of whether a device automatically sends a data request
+                           //!< command if its address is listed in a beacon frame.
+    macBattLifeExt = 0x43, //!< Indication of whether BLE, through the reduction of coordinator
+                           //!< receiver operation time during the CAP, is enabled.
+    macBattLifeExtPeriods = 0x44,  //!< In BLE mode, the number of backoff periods during which the
+                                   //!< the receiver is enabled after the IFS following a beacon.
+    macBeaconPayload = 0x45,       //!< The contents of the beacon payload.
+    macBeaconPayloadLength = 0x46, //!< The length in octets of the beacon payload.
+    macBeaconOrder = 0x47,  //!< Specification of how often the coordinator transmits its beacon.
+    macBeaconTxTime = 0x48, //!< The time that the device transmitted its last beacome frame,
+                            //!< in symbol periods.
+    macBsn = 0x49,          //!< The sequence number added to the transmitted beacon frame.
+    macCoordExtendedAddress = 0x4a, //!< The 64-bit address of the coordinator through which
+                                    //!< the device is associated.
+    macCoordShortAddress = 0x4b, //!< The 16-bit short address assigned to the coordinator through
+                                 //!< which the device is associated. 0xFFFE = Ext address mode
+                                 //!< 0xFFFF = Unknown.
+    macDSN = 0x4c, //!< The sequence number added to the transmitted data or MAC command frame.
+    macGTSPermit = 0x4d,      //!< True if the PAN coordinator is to accept GTS requests.
+    macMaxCSMABackoff = 0x4e, //!< The maximum number of backoffs the CSMA-CA algorithm
+                              //!< will attempt before declaring a channel access failure.
+    macMinBE = 0x4f, //!< The minimum value of the backoff exponent (BE) in the CSMA-CA algorithm.
+    macExtendedAddress = 0x6f, //!< The extended address of the device (64 bit address). The id
+                               //!< is not compliant for 2003 and 2006 versions, but this attribute
+                               //!< is later on added to the Pib attributes in 2011 and subsequent
+                               //!< editions of the standard.
+    macPanId = 0x50,           //!< The 16-bit identifier of the Personal Area Network (PAN).
+    macPromiscuousMode = 0x51, //!< Indication of whether the MAC sublayer is in a promiscuous
+                               //!< mode. True indicates that the MAC sublayer accepts all frames.
+    macRxOnWhenIdle = 0x52,    //!< Indication of whether the MAC is enabled during idle periods.
+    macShortAddress = 0x53,    //!< The short address of the device (16 bit address).
+    macSuperframeOrder = 0x54, //!< The length of the active portion of the outgoing superframe,
+                               //!< including the beacon frame.
+    macTransactionPersistenceTime = 0x55, //!< The maximum time (in unit periods) that a
+                                          //!< transaction is stored by a coordinator and
+                                          //!< indicated in its beacon.
+    macMaxFrameRetries = 0x59,  //!< The maximum number of retries allowed after a transmission
+                                //!< failure.
+    macResponseWaitTime = 0x5a, //!< The maximum time in multiples of aBaseSuperframeDuration, a
+                                //!< device shall wait for a response command frame to be
+                                //!< available following a request command frame.
     unsupported = 255
     // TODO: complete other MAC pib attributes
 };
@@ -269,7 +309,7 @@
  *
  * IEEE802.15.4-2011 PHY PIB Attributes Table 52 in section 6.4.2
  */
-struct LrWpanMacPibAttributes : public SimpleRefCount<LrWpanMacPibAttributes>
+struct MacPibAttributes : public SimpleRefCount<MacPibAttributes>
 {
     Ptr<Packet> macBeaconPayload;      //!< The contents of the beacon payload.
     uint8_t macBeaconPayloadLength{0}; //!< The length in octets of the beacon payload.
@@ -288,9 +328,9 @@
  */
 struct McpsDataConfirmParams
 {
-    uint8_t m_msduHandle{0};                                      //!< MSDU handle
-    LrWpanMacStatus m_status{LrWpanMacStatus::INVALID_PARAMETER}; //!< The status
-                                                                  //!< of the last MSDU transmission
+    uint8_t m_msduHandle{0};                          //!< MSDU handle
+    MacStatus m_status{MacStatus::INVALID_PARAMETER}; //!< The status
+                                                      //!< of the last MSDU transmission
 };
 
 /**
@@ -345,7 +385,7 @@
                                        //!< which the frame was intended.
     Mac64Address m_dstExtAddr;         //!< The extended address of the device for
                                        //!< which the frame was intended.
-    LrWpanMacStatus m_status{LrWpanMacStatus::INVALID_PARAMETER}; //!< The communication status
+    MacStatus m_status{MacStatus::INVALID_PARAMETER}; //!< The communication status
 };
 
 /**
@@ -365,8 +405,8 @@
  */
 struct MlmeStartConfirmParams
 {
-    LrWpanMacStatus m_status{LrWpanMacStatus::INVALID_PARAMETER}; //!< The status of
-                                                                  //!< a MLME-start.request
+    MacStatus m_status{MacStatus::INVALID_PARAMETER}; //!< The status of
+                                                      //!< a MLME-start.request
 };
 
 /**
@@ -376,10 +416,10 @@
  */
 struct PanDescriptor
 {
-    LrWpanAddressMode m_coorAddrMode{SHORT_ADDR}; //!< The coordinator addressing mode corresponding
-                                                  //!< to the received beacon frame.
-    uint16_t m_coorPanId{0xffff};                 //!< The PAN ID of the coordinator as specified in
-                                                  //!<  the received beacon frame.
+    AddressMode m_coorAddrMode{SHORT_ADDR}; //!< The coordinator addressing mode corresponding
+                                            //!< to the received beacon frame.
+    uint16_t m_coorPanId{0xffff};           //!< The PAN ID of the coordinator as specified in
+                                            //!<  the received beacon frame.
     Mac16Address m_coorShortAddr; //!< The coordinator short address as specified in the coordinator
                                   //!< address mode.
     Mac64Address m_coorExtAddr;   //!< The coordinator extended address as specified in the
@@ -403,18 +443,17 @@
  */
 struct MlmeScanConfirmParams
 {
-    LrWpanMacStatus m_status{
-        LrWpanMacStatus::INVALID_PARAMETER}; //!< The status of the scan request.
-    uint8_t m_scanType{MLMESCAN_PASSIVE};    //!< Indicates the type of scan
-                                             //!<  performed (ED,ACTIVE,PASSIVE,ORPHAN).
-    uint32_t m_chPage{0};                    //!< The channel page on which the scan was performed.
-    std::vector<uint8_t> m_unscannedCh;      //!< A list of channels given in the request which
-                                             //!<  were not scanned (Not valid for ED scans).
-    uint8_t m_resultListSize{0};             //!< The number of elements returned in the appropriate
-                                             //!<  result list. (Not valid for Orphan scan).
-    std::vector<uint8_t> m_energyDetList;    //!< A list of energy measurements, one for each
-                                             //!< channel searched during ED scan
-                                             //!< (Not valid for Active, Passive or Orphan Scans)
+    MacStatus m_status{MacStatus::INVALID_PARAMETER}; //!< The status of the scan request.
+    uint8_t m_scanType{MLMESCAN_PASSIVE};             //!< Indicates the type of scan
+                                                      //!<  performed (ED,ACTIVE,PASSIVE,ORPHAN).
+    uint32_t m_chPage{0};                 //!< The channel page on which the scan was performed.
+    std::vector<uint8_t> m_unscannedCh;   //!< A list of channels given in the request which
+                                          //!<  were not scanned (Not valid for ED scans).
+    uint8_t m_resultListSize{0};          //!< The number of elements returned in the appropriate
+                                          //!<  result list. (Not valid for Orphan scan).
+    std::vector<uint8_t> m_energyDetList; //!< A list of energy measurements, one for each
+                                          //!< channel searched during ED scan
+                                          //!< (Not valid for Active, Passive or Orphan Scans)
     std::vector<PanDescriptor> m_panDescList; //!< A list of PAN descriptor, one for each beacon
                                               //!< found (Not valid for ED and Orphan scans).
 };
@@ -427,8 +466,8 @@
 struct MlmeAssociateConfirmParams
 {
     Mac16Address m_assocShortAddr; //!< The short address used in the association request
-    LrWpanMacStatus m_status{LrWpanMacStatus::INVALID_PARAMETER}; //!< The status of
-                                                                  //!< a MLME-associate.request
+    MacStatus m_status{MacStatus::INVALID_PARAMETER}; //!< The status of
+                                                      //!< a MLME-associate.request
 };
 
 /**
@@ -451,8 +490,8 @@
  */
 struct MlmeSyncLossIndicationParams
 {
-    LrWpanMacStatus m_lossReason{LrWpanMacStatus::PAN_ID_CONFLICT}; //!< The reason for the lost
-                                                                    //!< of synchronization.
+    MacStatus m_lossReason{MacStatus::PAN_ID_CONFLICT}; //!< The reason for the lost
+                                                        //!< of synchronization.
     uint16_t m_panId{0}; //!< The PAN identifier with which the device lost synchronization or to
                          //!< which it was realigned.
     uint8_t m_logCh{11}; //!< The channel number on which the device lost synchronization or to
@@ -466,10 +505,10 @@
  */
 struct MlmeSetConfirmParams
 {
-    LrWpanMacStatus m_status{LrWpanMacStatus::UNSUPPORTED_ATTRIBUTE}; //!< The result of
-                                                                      //!< the request to write
-                                                                      //!< the PIB attribute.
-    LrWpanMacPibAttributeIdentifier id; //!< The id of the PIB attribute that was written.
+    MacStatus m_status{MacStatus::UNSUPPORTED_ATTRIBUTE}; //!< The result of
+                                                          //!< the request to write
+                                                          //!< the PIB attribute.
+    MacPibAttributeIdentifier id; //!< The id of the PIB attribute that was written.
 };
 
 /**
@@ -479,9 +518,9 @@
  */
 struct MlmePollConfirmParams
 {
-    LrWpanMacStatus m_status{LrWpanMacStatus::INVALID_PARAMETER}; //!< The confirmation
-                                                                  //!< status resulting from a
-                                                                  //!< MLME-poll.request.
+    MacStatus m_status{MacStatus::INVALID_PARAMETER}; //!< The confirmation
+                                                      //!< status resulting from a
+                                                      //!< MLME-poll.request.
 };
 
 /**
@@ -602,7 +641,7 @@
  * write attempt.
  */
 using MlmeGetConfirmCallback =
-    Callback<void, LrWpanMacStatus, LrWpanMacPibAttributeIdentifier, Ptr<LrWpanMacPibAttributes>>;
+    Callback<void, MacStatus, MacPibAttributeIdentifier, Ptr<MacPibAttributes>>;
 
 /**
  * \ingroup lr-wpan
@@ -719,17 +758,18 @@
      * \param id the attributed identifier
      * \param attribute the attribute value
      */
-    virtual void MlmeSetRequest(LrWpanMacPibAttributeIdentifier id,
-                                Ptr<LrWpanMacPibAttributes> attribute) = 0;
+    virtual void MlmeSetRequest(MacPibAttributeIdentifier id, Ptr<MacPibAttributes> attribute) = 0;
 
     /**
-     * IEEE 802.15.4-2011, section 6.2.5.1
+     * IEEE 802.15.4-2006, section 7.1.6.1
      * MLME-GET.request
      * Request information about a given PIB attribute.
+     * Note: The PibAttributeIndex parameter is not included because
+     * attributes that represent tables are not supported.
      *
      * \param id the attribute identifier
      */
-    virtual void MlmeGetRequest(LrWpanMacPibAttributeIdentifier id) = 0;
+    virtual void MlmeGetRequest(MacPibAttributeIdentifier id) = 0;
 
     /**
      * Set the callback for the confirmation of a data transmission request.
@@ -935,6 +975,7 @@
     MlmePollConfirmCallback m_mlmePollConfirmCallback;
 };
 
+} // namespace lrwpan
 } // namespace ns3
 
 #endif /* LR_WPAN_MAC_BASE_H*/
